  <nz-modal [(nzVisible)]="isVisible"
              nzTitle="Create New User"
              [nzFooter]="null"
              (nzOnCancel)="this.isVisible = false">
        <form nz-form
              [formGroup]="this.validateForm"
              #form="ngForm"
              class="register-form"
              (ngSubmit)="submitForm(form)">
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">Name</nz-form-label>
          <nz-form-control nz-col nzFlex="5" [nzErrorTip]="nameError" [nzValidateStatus]="this.nzValidationStatus('name')" nzHasFeedback>
            <input type="text"
                    nz-input
                    formControlName="name"
                    placeholder="Name" />
            <ng-template #nameError>
              <ng-container *ngIf="this.validateForm.controls['name'].hasError('required')">
                Please enter a name!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['name'].hasError('minlength')">
                The name should contain at least 3 characters!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['name'].hasError('maxlength')">
                The name should not contain more than 35 characters!
              </ng-container>
            </ng-template>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">Username</nz-form-label>
          <nz-form-control nz-col nzFlex="5" [nzErrorTip]="usernameError" [nzValidateStatus]="this.nzValidationStatus('username')" nzHasFeedback>
              <input type="text"
                    nz-input
                    formControlName="username"
                    placeholder="Username" />
            <ng-template #usernameError>
              <ng-container *ngIf="this.validateForm.controls['username'].hasError('required')">
                Please enter a username!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['username'].hasError('cannotContainSpace')">
                The username cannot contain a space!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['username'].hasError('minlength')">
                The username should contain at least 3 characters!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['username'].hasError('maxlength')">
                The username should not contain more than 16 characters!
              </ng-container>
            </ng-template>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">Email</nz-form-label>
          <nz-form-control nz-col nzFlex="5" [nzErrorTip]="emailError" [nzValidateStatus]="this.nzValidationStatus('email')" nzHasFeedback>
            <input type="email"
                    nz-input
                    formControlName="email"
                    placeholder="Email" />
            <ng-template #emailError>
              <ng-container *ngIf="this.validateForm.controls['email'].hasError('required')">
                Please enter an email!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['email'].hasError('maxlength')">
                The email should not contain more than 60 characters!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['email'].hasError('pattern')">
                The email should be valid!
              </ng-container>
            </ng-template>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">Password</nz-form-label>  
          <nz-form-control nz-col nzFlex="5" [nzErrorTip]="passwordError" [nzValidateStatus]="this.nzValidationStatus('password')" nzHasFeedback>
            <input type="password"
                    nz-input
                    (ngModelChange)="this.validateForm.controls['confirmPassword'].updateValueAndValidity()"
                    formControlName="password"
                    placeholder="Password" />
            <ng-template #passwordError>
              <ng-container *ngIf="this.validateForm.controls['password'].hasError('required')">
                Please enter a valid password!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['password'].hasError('minlength')">
                The password should contain at least 5 characters!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['password'].hasError('maxlength')">
                The password should not contain more than 32 characters!
              </ng-container>
              <ng-container *ngIf="this.validateForm.controls['password'].hasError('pattern')">
                The password should contain at least one letter, one number and one special character!
              </ng-container>
            </ng-template>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">Confirm password</nz-form-label>  
          <nz-form-control nz-col nzFlex="5" [nzErrorTip]="passwordError1" [nzValidateStatus]="this.nzValidationStatus('confirmPassword')" nzHasFeedback>
            <input type="password"
                    nz-input
                    formControlName="confirmPassword"
                    placeholder="Confirm Password" />
            <ng-template #passwordError1>
              <ng-container *ngIf="this.validateForm.controls['confirmPassword'].hasError('passwordsNotTheSame')">
                Passwords must match!
              </ng-container>
            </ng-template>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <nz-form-label nz-col nzFlex="2">User Role</nz-form-label>
          <nz-form-control nz-col nzFlex="5">
              <nz-select formControlName="role">
                <nz-option *ngFor="let role of roles" [nzValue]="role" [nzLabel]="role"></nz-option>
              </nz-select>
          </nz-form-control>
        </nz-form-item>
        <nz-form-item>
          <div nz-col nzFlex="2"></div>
          <nz-form-control nz-col nzFlex="5">
            <button nz-button
                class="register-form-button register-form-margin"
                [nzType]="'primary'"
                type="submit"
                [disabled]="!this.validateForm.valid">Create</button>
          </nz-form-control>
        </nz-form-item>
      </form>
  </nz-modal>